import errno
import glob
import os

import requests

import auth

# This python util will extract based on cw.json and uses _split API and get the entities based on crosswalk


if __name__ == '__main__':

    src_env = ''
    src_tenant_id = ''
    src_entity_uri = ''

    target_env = ''
    target_tenant_id = ''

    path = 'path/to/files' + src_entity_uri + '/'

    try:
        os.makedirs(path)
    except OSError as e:
        if e.errno != errno.EEXIST:
            raise

    url = "https://" + src_env + \
          ".reltio.com/reltio/api/" \
          + src_tenant_id + \
          "/entities/" + src_entity_uri + "?select=crosswalks"

    payload = {}
    headers = {
        'Authorization': 'Bearer ' + auth.get_access_token(),
        'Content-Type': 'application/json'
    }

    response = requests.request("GET", url, headers=headers, data=payload)
    list_of_crosswalk = response.json()['crosswalks']

    json_list = []
    for d in list_of_crosswalk:
        url = "https://" + src_env + ".reltio.com/reltio/api/" \
              + src_tenant_id + \
              "/entities/" \
              + src_entity_uri + \
              "/_slice" \
              "?" \
              "crosswalkValue=" \
              + d['value'] + \
              "&options=cleanEntity&select=attributes,type,crosswalks"

        src = d['type']

        if "Cleanser" in src:
            continue

        payload = {}
        headers = {
            'Authorization': 'Bearer ' + auth.get_access_token(),
            'Content-Type': 'application/json',
            'Source-System': src.split('/')[2]
        }
        print(url)
        print(src.split('/')[2])
        print(d['value'])

        response1 = requests.request("GET", url, headers=headers, data=payload)

        print(response1.text.encode('utf8'))

        my_data_file = open(path + '/' + d['value'] + '_' + src.split('/')[2] + '.json', 'wb')
        my_data_file.write(response1.text.encode('utf8'))
        json_list.append(response1.text.encode('utf8'))
        my_data_file.close()

    url = "https://" + target_env + ".reltio.com/reltio/api/" + target_tenant_id + "/entities"
    headers = {
        'Authorization': 'Bearer ' + auth.get_access_token(),
        'Content-Type': 'application/json'
    }

    # lines = json.dumps(json_list)
    print(json_list)
    # response2 = requests.request("POST", url, headers=headers, data=lines)

    # print(response2.text.encode('utf8'))

    join_file_path = path + '*.json'
    files = glob.glob(join_file_path)

    my_data_file = open(path + 'Final.json', 'a')

    for file in files:
        f = open(file, 'r')
        data = f.read()
        my_data_file.write(data)
        my_data_file.write(',')
        f.close()

    my_data_file.close()
